## org.freedesktop.NetworkManager.Settings.Connection

org.freedesktop.NetworkManager.Settings.Connection

## Methods

    Update        (IN  a{sa{sv}} properties);
    UpdateUnsaved (IN  a{sa{sv}} properties);
    Delete        ();
    GetSettings   (OUT a{sa{sv}} settings);
    GetSecrets    (IN  s         setting_name,
                   OUT a{sa{sv}} secrets);
    ClearSecrets  ();
    Save          ();

## Signals

    Updated           ();
    Removed           ();
    PropertiesChanged (a{sv} properties);

## Properties

    Unsaved  readable   b

## Description

Represents a single network connection configuration.

## Method Details

### The Update() method

    Update (IN  a{sa{sv}} properties);

Update the connection with new settings and properties (replacing all previous settings and properties) and save the connection to disk. Secrets may be part of the update request, and will be either stored in persistent storage or sent to a Secret Agent for storage, depending on the flags associated with each secret.

`IN a{sa{sv}} `properties``: | New connection settings, properties, and (optionally) secrets.

### The UpdateUnsaved() method

    UpdateUnsaved (IN  a{sa{sv}} properties);

Update the connection with new settings and properties (replacing all previous settings and properties) but do not immediately save the connection to disk. Secrets may be part of the update request and may sent to a Secret Agent for storage, depending on the flags associated with each secret. Use the 'Save' method to save these changes to disk. Note that unsaved changes will be lost if the connection is reloaded from disk (either automatically on file change or due to an explicit ReloadConnections call).

`IN a{sa{sv}} `properties``: | New connection settings, properties, and (optionally) secrets.

### The Delete() method

    Delete ();

Delete the connection.

### The GetSettings() method

    GetSettings (OUT a{sa{sv}} settings);

Get the settings maps describing this network configuration. This will never include any secrets required for connection to the network, as those are often protected. Secrets must be requested separately using the GetSecrets() call.

`OUT a{sa{sv}} `settings``: | The nested settings maps describing this object.

### The GetSecrets() method

    GetSecrets (IN  s         setting_name,
                OUT a{sa{sv}} secrets);

Get the secrets belonging to this network configuration. Only secrets from persistent storage or a Secret Agent running in the requestor's session will be returned. The user will never be prompted for secrets as a result of this request.

`IN s `setting_name``: | Name of the setting to return secrets for. If empty, all all secrets will be returned.
`OUT a{sa{sv}} `secrets``: | Nested settings maps containing secrets.

### The ClearSecrets() method

    ClearSecrets ();

Clear the secrets belonging to this network connection profile.

### The Save() method

    Save ();

Saves a "dirty" connection (that had previously been updated with UpdateUnsaved) to persistent storage.

## Signal Details

### The "Updated" signal

    Updated ();

Emitted when any settings or permissions change. When handling this signal, clients should re-read the connection using the GetSettings method to get the changes and to ensure the client still has permission to access the connection.

### The "Removed" signal

    Removed ();

Emitted when this connection is no longer available. This happens when the connection is deleted or if it is no longer accessible by any of the system's logged-in users. After receipt of this signal, the object no longer exists. Also see the Settings.ConnectionRemoved signal.

### The "PropertiesChanged" signal

    PropertiesChanged (a{sv} properties);

DEPRECATED. Use the standard "PropertiesChanged" signal from "org.freedesktop.DBus.Properties" instead which exists since version NetworkManager 1.2.0.

`a{sv} `properties``: | A dictionary mapping property names to variant boxed values.

## Property Details

### The "Unsaved" property

    Unsaved  readable   b

If set, indicates that the in-memory state of the connection does not match the on-disk state. This flag will be set when UpdateUnsaved() is called or when any connection details change, and cleared when the connection is saved to disk via Save() or from internal operations.